unit Demo_;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Grids, Menus, ClipBrd, MFHtScan;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit3: TEdit;
    CheckBox1: TCheckBox;
    Edit6: TEdit;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    Memo7: TMemo;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Log: TTabSheet;
    StatusBar1: TStatusBar;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    CheckBox2: TCheckBox;
    Label4: TLabel;
    Edit2: TEdit;
    Label5: TLabel;
    HttpScan1: THttpScan;
    Memo4: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit6KeyPress(Sender: TObject; var Key: Char);
    procedure HttpScan1Error(Sender: TObject; Url: String;
      ErrorCode: Cardinal; ErrorMsg: String);
    procedure HttpScan1Working(Sender: TObject; Working_: Boolean);
    procedure CheckBox1Click(Sender: TObject);
    procedure HttpScan1UpdatedStats(Sender: TObject; InQueue, Downloading,
      ToAnalyze, Done, Retries, Errors: Integer);
    procedure HttpScan1PageReceived(Sender: TObject; HostName, Url, Head,
      Body: String);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Exit1Click(Sender: TObject);
    procedure HttpScan1LinkFound(Sender: TObject; UrlFound, TypeLink,
      FromUrl, HostName, UrlPath, UrlPathWithFile, ExtraInfos: String;
      var WriteToFile: String; HrefOrSrc: Char; CountArea: Integer;
      var FollowIfHtmlLink: Boolean);
  private
    CountJpg, CountElse : integer;
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

var
  Form1: TForm1;
  WHEEL : char;

implementation

{$R *.DFM}

procedure TForm1.Edit3Change(Sender: TObject);
var
   Value : integer;
begin
   Value := StrToInt (Edit3.Text);
   if Value = -1 then begin
      Edit3.Text := '254';
   end;
   if Value = 255 then begin
      Edit3.Text := '0';
   end;
   if Value > 0 then begin
      if Assigned (HttpScan1) then HttpScan1.DepthSearchLevel := Value;
   end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
   HttpScan1.ConcurrentDownloads := strtoint (Edit6.Text);
   HttpScan1.DepthSearchLevel := strtoint (Edit3.Text);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   Ok : boolean;
begin
   HttpScan1.FileOfResults := Edit2.Text;
   HttpScan1.StayOnSite := CheckBox1.Checked;
   HttpScan1.ConcurrentDownloads := strtoint (Edit6.Text);
   HttpScan1.DepthSearchLevel := strtoint (Edit3.Text);

   Ok := HttpScan1.Start (edit1.text);

   if Ok then begin
      CountJpg := 0;
      CountElse := 0;

      Edit1.Text := HttpScan1.StartingUrl;
      Memo1.Text := '';
      Memo2.Text := '';
      Memo3.Text := '';
      Memo4.Text := '';
   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   StatusBar1.SimpleText := StatusBar1.SimpleText + '    stopping...';
   HttpScan1.Stop;
end;

function TurnWheel : char;
begin
   case WHEEL of
      '/' : WHEEL := '-';
      '-' : WHEEL := '\';
      '\' : WHEEL := '|';
   else
      WHEEL := '/';
   end;
   TurnWheel := WHEEL;
end;

procedure TForm1.Edit6Change(Sender: TObject);
var
   Value : integer;
begin
   Value := StrToInt (Edit6.Text);
   if Value > 0 then begin
      if Assigned (HttpScan1) then HttpScan1.ConcurrentDownloads := Value;
   end;


   if Assigned (HttpScan1) then HttpScan1.ConcurrentDownloads := StrToInt (Edit6.Text);

end;

procedure TForm1.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
   Key := char(0);
end;

procedure TForm1.Edit6KeyPress(Sender: TObject; var Key: Char);
begin
   Key := char(0);
end;

procedure TForm1.HttpScan1Error(Sender: TObject; Url: String;
  ErrorCode: Cardinal; ErrorMsg: String);
begin
   Memo1.Lines.Add ('ERROR ' + inttostr (ErrorCode) + ' : ' + Url);
end;

procedure TForm1.HttpScan1Working(Sender: TObject; Working_: Boolean);
begin
   if Working_ then begin
      Statusbar1.SimpleText := '   Working...';
   end
   else begin
      Statusbar1.SimpleText := StatusBar1.SimpleText + '     Done.';
      messagedlg ('Done.', mtinformation, [mbok], 0);
   end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
   HttpScan1.StayOnSite := CheckBox1.Checked;
end;

procedure TForm1.HttpScan1UpdatedStats(Sender: TObject; InQueue,
  Downloading, ToAnalyze, Done, Retries, Errors: Integer);
begin
   Memo7.Text :=    '   IN QUEUE : ' + inttostr (InQueue);
   Memo7.Lines.Add ('downloading : ' + inttostr (Downloading));
   Memo7.Lines.Add (' to analyze : ' + inttostr (ToAnalyze));
   Memo7.Lines.Add ('       DONE : ' + inttostr (Done));
   Memo7.Lines.Add ('    retries : ' + inttostr (Retries));
   Memo7.Lines.Add ('     errors : ' + inttostr (Errors));
end;

procedure TForm1.HttpScan1PageReceived(Sender: TObject; HostName, Url,
  Head, Body: String);
begin
   if pos ('robots.txt', Url) > 0 then begin
      memo4.Text := 'robots.txt found on ' + Url + ':' + chr(13) + chr(10)
                  + '-------------------' + chr(13) + chr(10) + Body;
   end;
   Memo2.Text := Head;
   Memo3.Text := Body;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   CanClose := true;
   if HttpScan1.Working then begin
      if not HttpScan1.Stopping then begin
         CanClose := false;
         if MessageDlg ('Do you really want to quit ?', mtConfirmation, [mbYes,mbCancel], 0) = mrCancel then begin
         end
         else begin
            HttpScan1.Exit;
         end;
      end;
   end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
   Close;
end;

procedure TForm1.HttpScan1LinkFound(Sender: TObject; UrlFound, TypeLink,
  FromUrl, HostName, UrlPath, UrlPathWithFile, ExtraInfos: String;
  var WriteToFile: String; HrefOrSrc: Char; CountArea: Integer;
  var FollowIfHtmlLink: Boolean);
begin
   // if nothing is assigned to WriteToFile, all the links are written to the result file in a default format.

   // if you want a link not to be written to the result file, add a WriteToFile := ''; E.g:
   // if TypeLink <> 'mail' then begin
   //    WriteToFile := '';
   // end;

   // if you want to write you own fields, set the line to write in the WriteToFile string. E.g:
   // WriteToFile := UrlFound + ';' + TypeLink + ';' + Hostname;

   if TypeLink = 'jpg' then begin
      inc (CountJpg);
   end
   else begin
      inc (CountElse);
   end;
   if CheckBox2.checked then begin
      Memo1.Lines.Add (typelink + ' ' + UrlFound);

      // replace the previous line by the line below to see the couples of HREF/SRC associated by their CountArea number
      // Memo1.Lines.Add (Format ('%5u ', [CountArea]) + HRefOrSrc + ' ' + typelink + ' ' + UrlFound);

   end;

   StatusBar1.SimpleText := '   jpg : ' + inttostr (CountJpg) + '  (' + TurnWheel + ')  others : ' + IntToStr (CountElse);

end;

end.
